<script setup>
import { toast } from 'bulma-toast'

const router = useRouter()
const activeSave = useActiveSave()

definePageMeta({
  middleware: ['auth', 'org']
})

const client = useCookie('logship_client')
const clientId = useCookie('logship_client_id')
const organization = useCookie('logship_organization')
const organizationId = useCookie('logship_organization_id')

const form = ref({
  id: '',
  uid: '',
  client: client.value?.Name || '',
  clientId: clientId.value || '',
  organization: organization.value?.Name || '',
  organizationId: organizationId.value || '',
  name: '',
  description: '',
  shippingServiceCode: '',
  trackingURL: '',
  isActive: true,
  isInternational: false,
  isOnline: false,
  isResidential: false,
  isSaturdayDelivery: false,
  shippingProcessorCfg: '',
  shippingProcessorCfgId: '',
  processing: false,
  alert: {
    status: '',
    message: '',
    processing: false
  }
})

const back = () => {
  if(activeSave.value) {
    toast({
      message: 'Save button is active, please submit the data before leaving!',
      type: 'is-warning',
      duration: 2000
    })
  } else {
    router.push('/materials/shipper-configurations')
  }
}

const save = async (record) => {
  form.value = record
  
  if(form.value.name !== '') {
    activeSave.value = true
  } else {
    activeSave.value = false
  }
}

const submit = async (saveType = '') => {
  form.value.alert.processing = true
  activeSave.value = true

  const res = await $fetch('/api/materials/shipper-configurations/store', {
    method: 'POST',
    headers: useRequestHeaders(['cookie']),
    body: {
      organizationId: form.value.organizationId,
      name: form.value.name,
      description: form.value.description,
      shippingServiceCode: form.value.shippingServiceCode,
      trackingURL: form.value.trackingURL,
      isActive: form.value.isActive,
      isInternational: form.value.isInternational,
      isOnline: form.value.isOnline,
      isResidential: form.value.isResidential,
      isSaturdayDelivery: form.value.isSaturdayDelivery,
      shippingProcessorCfgId: form.value.shippingProcessorCfgId,
    }
  })

  if(Number(res.status) === 200) {
    form.value.alert.processing = false
    activeSave.value = false
    if(saveType === 'preview') {
      router.push('/materials/shipper-configurations/' + res.id + '/view')
    } else if(saveType === 'changes' || saveType === 'onlysave') {
      router.push('/materials/shipper-configurations/'+res.id+'/edit')
      toast({
        message: 'Saved!',
        type: 'is-success',
        duration: 2000
      })
    } else {
      back()
    }
  } else {
    //form.value.alert.status = res.status
    //form.value.alert.message = res.message
    form.value.alert.processing = false
    activeSave.value = false
    toast({
      message: res.message || 'Save error',
      type: 'is-danger',
      duration: 2000
    })
    //window.scrollTo(0, 0)
  }
}

const breadCrumb = computed(() => ([
  { link: '#', text: 'Materials'},
  { link: '/materials/shipper-configurations', text: 'Shipper Configurations'},
  { link: '#', text: 'Add Shipper Configuration', active: true}
]))
</script>

<template>
  <Head>
    <Title>Add Shipper Configuration</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />
    
    <div class="bannercontrol">
      <div class="d-flex gap-10px">
        <button type="button" @click="submit('onlysave')" class="button" :class="(form.name === '' || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Save</button>
      </div>
      <div>
        <div class="d-flex gap-10px">
          <button v-if="activeSave" type="button" @click="activeSave = false; back();" class="button">
            <span class="tf-icon ti ti-square-x ti-xs me-1 color-inherit"></span> Abort
          </button>
          <button type="button" @click="back" class="button">
            <span class="tf-icon ti ti-chevron-left ti-xs me-1 color-inherit"></span> Back
          </button>
        </div>
      </div>
    </div>

    <div>
      <div class="banner">
        <div>
          <MaterialsShipperConfigurationForm v-model="form" @save="save" />
        </div>
        <div class="opacity-0.6 pointerEvents-none">
          <MaterialsShipperConfigurationDetailRecord action="create" :info="form" />
        </div>
      </div>
    </div>
  </NuxtLayout>
</template>